<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="550px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
<el-form-item label="种植ID" prop="land_id">
    <el-select
        v-model="formData.plant_id"
        filterable
        remote
        reserve-keyword
        placeholder="请输入种植信息"
        :remote-method="queryLandPlant"
        :loading="loading"
      >
        <el-option
          v-for="item in landPlantOptions"
          :key="item.value"
          :label="item.label"
          :value="item.value"
        />
      </el-select>
</el-form-item>
                <el-form-item label="操作类型" prop="type">
    <el-select class="flex-1" v-model="formData.type" clearable placeholder="请选择操作类型">
        <el-option 
            v-for="(item, index) in dictData.land_plant_action"
            :key="index" 
            :label="item.name"
            :value="parseInt(item.value)"
        />
    </el-select>
</el-form-item>
                <el-form-item label="操作" prop="type_text">
    <el-input v-model="formData.type_text" clearable placeholder="请输入操作" />
</el-form-item>
                <el-form-item label="操作详情" prop="detail">
    <el-input class="flex-1" v-model="formData.detail" type="textarea" rows="4" clearable placeholder="请输入操作详情" />
</el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="landPlantActionEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiLandPlantActionAdd, apiLandPlantActionEdit, apiLandPlantActionDetail, apiLandPlantLists, getUserList } from '@/api/land_plant_action'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑土地种植操作' : '新增土地种植操作'
})

// 表单数据
const formData = reactive({
    id: '',
    plant_id: '',
    type: '',
    type_text: '',
    detail: '',
})


// 表单验证
const formRules = reactive<any>({
    plant_id: [{
        required: true,
        message: '请输入种植ID',
        trigger: ['blur']
    }],
    type: [{
        required: true,
        message: '请选择操作类型',
        trigger: ['blur']
    }],
})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
    
    
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiLandPlantActionDetail({
        id: row.id
    })
    setFormData(data)
}

interface ListItem {
    value: string
    label: string
}
const landPlantOptions = ref<ListItem[]>([])
const loading = ref(false)

const queryLandPlant = async (query: string) => {
    if (query) {
        loading.value = true
        const landList = await apiLandPlantLists({
            keyword: query
        })
        loading.value = false
        if (landList.count > 0) {
            landPlantOptions.value = landList.lists.map((landPlant: any) => {
                return { value: `${landPlant.id}`, label: `ID: ${landPlant.id} / 种类: ${landPlant.kind} / 品牌: ${landPlant.breed}` }
            })
        } else {
            landPlantOptions.value = []
        }
        loading.value = false
    } else {
        landPlantOptions.value = []
    }
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData,  }
    mode.value == 'edit' 
        ? await apiLandPlantActionEdit(data) 
        : await apiLandPlantActionAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
